'use strict';

var typeId = 0;
function ActionReducer(initState, prefix) {
    var reducerFragments = Object.create(null);
    var createAction = function (type, reducer) {
        if (typeof type === 'function') {
            reducer = type;
            type = "@@ActionReducer-" + ++typeId;
        }
        type = prefix ? "" + prefix + type : type;
        var actionCreator = (function (payload) { return ({ type: type, payload: payload }); });
        actionCreator.type = type;
        reducerFragments[type] = reducer;
        return actionCreator;
    };
    var reducer = function (state, action) {
        if (state === void 0) { state = initState; }
        var reducerFragment = reducerFragments[action.type];
        return reducerFragment ? reducerFragment(state, action.payload) : state;
    };
    return { createAction: createAction, reducer: reducer };
}

module.exports = ActionReducer;
