(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory() :
  typeof define === 'function' && define.amd ? define(factory) :
  (global.ActionReducer = factory());
}(this, (function () { 'use strict';

  var typeId = 0;
  function ActionReducer(initState, prefix) {
      var reducerFragments = Object.create(null);
      var createAction = function (type, reducer) {
          if (typeof type === 'function') {
              reducer = type;
              type = "@@ActionReducer-" + ++typeId;
          }
          type = prefix ? "" + prefix + type : type;
          var actionCreator = (function (payload) { return ({ type: type, payload: payload }); });
          actionCreator.type = type;
          reducerFragments[type] = reducer;
          return actionCreator;
      };
      var reducer = function (state, action) {
          if (state === void 0) { state = initState; }
          var reducerFragment = reducerFragments[action.type];
          return reducerFragment ? reducerFragment(state, action.payload) : state;
      };
      return { createAction: createAction, reducer: reducer };
  }

  return ActionReducer;

})));
