export interface AnyAction {
    type: any;
    [extraProps: string]: any;
}
export interface Action<P> {
    type: string | symbol;
    payload: P;
}
export interface PayloadActionCreator<P> {
    (payload: P): Action<P>;
    type: string | symbol;
}
export interface EnptyActionCreator {
    (): Action<undefined>;
    type: string | symbol;
}
export interface OptionalActionCreator<P> {
    (payload?: P): Action<P | undefined>;
    type: string | symbol;
}
export declare type ReducerFragment<S, P> = (state: Readonly<S>, payload: P) => S;
export interface CreateEnptyActionCreator<S> {
    (reducer: ReducerFragment<S, void>): EnptyActionCreator;
    (type: string | symbol, reducer: ReducerFragment<S, void>): EnptyActionCreator;
}
export interface CreatePayloadActionCreator<S> {
    <P>(reducer: ReducerFragment<S, P>): PayloadActionCreator<P>;
    <P>(type: string | symbol, reducer: ReducerFragment<S, P>): PayloadActionCreator<P>;
}
export interface CreateAction<S> extends CreateEnptyActionCreator<S>, CreatePayloadActionCreator<S> {
}
export default function ActionReducer<S>(initState: S, prefix?: string): {
    createAction: CreateAction<S>;
    reducer: (state: S | undefined, action: AnyAction) => S;
};
